Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/Version.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/Version.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/Version.java	(revision 12)
@@ -29,7 +29,7 @@
 public class Version {
 
 	public static final String s_releaseMajor = "3";
-	public static final String s_releaseMinor = "0";
+	public static final String s_releaseMinor = "1";
 
 	public static String asString() {
 		return s_releaseMajor + "." + s_releaseMinor;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaResolveExpressionsVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaResolveExpressionsVisitor.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaResolveExpressionsVisitor.java	(revision 12)
@@ -77,6 +77,7 @@
 import org.momut.ooas.ast.types.IntType;
 import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.MapType;
+import org.momut.ooas.ast.types.MetaType;
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.TupleType;
@@ -436,9 +437,19 @@
 			{
 				if (!Type.TypeEqual(item.type(), type))
 				{
-					final Expression cast = new UnaryOperator(ExpressionKind.Cast, item, item.line(), item.pos());
-					cast.SetType(type);
-					newitems.add(cast);
+					// one exception: lists will not be cast. instead we descend into the inner-most lists and statically update their inner types
+					if(item.kind() == ExpressionKind.ListConstr)
+					{
+						item.Accept(new OoaStaticListCastVisitor((ListType) type));
+						item.SetType(type);
+						newitems.add(item);
+					}
+					else
+					{
+						final Expression cast = new UnaryOperator(ExpressionKind.Cast, item, item.line(), item.pos());
+						cast.SetType(type);
+						newitems.add(cast);
+					}
 				}
 				else
 					newitems.add(item);
@@ -904,6 +915,13 @@
 		expression.SetLeftChild(lhs);
 
 
+		if (staticAccess) {
+			if (atype.kind() != TypeKind.MetaType)
+				return Error(access, "Expected meta type.");
+			atype = ((MetaType)atype).Type();
+		}
+
+
 		switch (atype.kind())
 		{
 		case OoActionSystemType:
@@ -957,7 +975,7 @@
 			break;
 		default:
 			/*error, we can not access an element with '.' in any other type*/
-			return Error(expression, "Expected: System, Enum, Func, or QR type");
+			return Error(expression, "Expected: System, Enum, or Function");
 		}
 
 		expression.SetType(expression.right().type());
@@ -1157,7 +1175,7 @@
 			if (lt.kind() != TypeKind.MapType)
 				return Error(expression, "Range restriction operator expects map on LHS");
 			if (rt.kind() != TypeKind.ListType)
-				return Error(expression, "Rangle restriction operator expects list on RHS");
+				return Error(expression, "Range restriction operator expects list on RHS");
 			final ListType rangelist = (ListType)rt;
 			domMap = (MapType)lt;
 			if (!Type.TypeEqual(rangelist.innerType(), domMap.fromType()))
@@ -1191,21 +1209,40 @@
 				return lhs;
 			if (la.innerType().kind() == TypeKind.Null || la.maxNumberOfElements() == 0)
 				return rhs;
-			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
-				return Error(expression, String.format("Set/List concatenation expects two lists of same type. (%s <> %s)", la.toString(), lb.toString()));
-			ListType resultList = new ListType(la.innerType(),
-					la.maxNumberOfElements() + lb.maxNumberOfElements(), null);
-			expression.SetType(resultList);
+
+			if (!Type.TypeEqual(la.innerType(), lb.innerType())) {
+				final ListType coverType = (ListType) Type.CoverType(la, lb);
+				if(coverType == null)
+					return Error(expression, String.format("Set/List concatenation expects two lists of same type. (%s <> %s)", la.toString(), lb.toString())); // FIXME adjust error message
+
+				if(!Type.TypeEqual(la, coverType))
+					lhs.Accept(new OoaStaticListCastVisitor(coverType));
+				if(!Type.TypeEqual(lb, coverType))
+					rhs.Accept(new OoaStaticListCastVisitor(coverType));
+
+				expression.SetType(new ListType(coverType.innerType(), la.maxNumberOfElements() + lb.maxNumberOfElements(), null));
+			} else
+				expression.SetType(new ListType(la.innerType(), la.maxNumberOfElements() + lb.maxNumberOfElements(), null));
+
 			break;
 		case diff:       // list of A * list of A -> list of A (does not respect dupes)
-			if (lt.kind() != TypeKind.ListType ||
-			rt.kind() != TypeKind.ListType)
+			if (lt.kind() != TypeKind.ListType || rt.kind() != TypeKind.ListType)
 				return Error(expression, "Set difference expects two lists.");
 			la = (ListType)lt;
 			lb = (ListType)rt;
-			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
-				return Error(expression, "Set difference expects two lists of same type.");
-			expression.SetType(la);
+			if (!Type.TypeEqual(la.innerType(), lb.innerType())) {
+				final ListType coverType = (ListType) Type.CoverType(la, lb);
+				if(coverType == null)
+					return Error(expression, "Set difference expects two lists of same type."); // FIXME adjust error message
+
+				if(!Type.TypeEqual(la, coverType))
+					lhs.Accept(new OoaStaticListCastVisitor(coverType));
+				if(!Type.TypeEqual(lb, coverType))
+					rhs.Accept(new OoaStaticListCastVisitor(coverType));
+
+				expression.SetType(coverType);
+			} else
+				expression.SetType(la);
 			break;
 		case inter:      // list of A * list of A -> list of A (does not respect dupes)
 			if (lt.kind() != TypeKind.ListType ||
@@ -1213,9 +1250,17 @@
 				return Error(expression, "Set intersection expects two lists.");
 			la = (ListType)lt;
 			lb = (ListType)rt;
-			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
-				return Error(expression, "Set intersection expects two lists of same type.");
-			expression.SetType(la.maxNumberOfElements() > lb.maxNumberOfElements() ? la : lb);
+			if (!Type.TypeEqual(la.innerType(), lb.innerType())) {
+				final ListType coverType = (ListType) Type.CoverType(la, lb);
+				if(coverType == null)
+					return Error(expression, "Set intersection expects two lists of same type.");
+				if(!Type.TypeEqual(la, coverType))
+					lhs.Accept(new OoaStaticListCastVisitor(coverType));
+				if(!Type.TypeEqual(lb, coverType))
+					rhs.Accept(new OoaStaticListCastVisitor(coverType));
+				expression.SetType(coverType);
+			} else
+				expression.SetType(la.maxNumberOfElements() > lb.maxNumberOfElements() ? la : lb);
 			break;
 		case elemin:     // A * list of A -> bool
 		case notelemin:  // A * list of A -> bool
@@ -1231,13 +1276,20 @@
 			expression.SetType(new BoolType(null));
 			break;
 		case subset:     // list of A * list of A -> bool (does not respect dupes)
-			if (lt.kind() != TypeKind.ListType ||
-			rt.kind() != TypeKind.ListType)
+			if (lt.kind() != TypeKind.ListType || rt.kind() != TypeKind.ListType)
 				return Error(expression, "Subset operation expects two lists.");
 			la = (ListType)lt;
 			lb = (ListType)rt;
-			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
-				return Error(expression, "Subset operation expects two lists of same type.");
+			if (!Type.TypeEqual(la.innerType(), lb.innerType())) {
+				final ListType coverType = (ListType) Type.CoverType(la, lb);
+				if(coverType == null)
+					return Error(expression, "Subset operation expects two lists of same type.");
+
+				if(!Type.TypeEqual(la, coverType))
+					lhs.Accept(new OoaStaticListCastVisitor(coverType));
+				if(!Type.TypeEqual(lb, coverType))
+					rhs.Accept(new OoaStaticListCastVisitor(coverType));
+			}
 			expression.SetType(new BoolType(null));
 			break;
 		case union:      // list of A * list of A -> list of A (does not respect dupes)
@@ -1252,11 +1304,18 @@
 			if (lb.innerType().kind() == TypeKind.Null || lb.maxNumberOfElements() == 0)
 				return lhs;
 
-			if (!Type.TypeEqual(la.innerType(), lb.innerType()))
-				return Error(expression, "Set union expects two lists of same type.");
-			resultList = new ListType(la.innerType(),
-					la.maxNumberOfElements() + lb.maxNumberOfElements(), null);
-			expression.SetType(resultList);
+			if (!Type.TypeEqual(la.innerType(), lb.innerType())) {
+				final ListType coverType = (ListType) Type.CoverType(la, lb);
+				if(coverType == null)
+					return Error(expression, "Set union expects two lists of same type.");
+				if(!Type.TypeEqual(la, coverType))
+					lhs.Accept(new OoaStaticListCastVisitor(coverType));
+				if(!Type.TypeEqual(lb, coverType))
+					rhs.Accept(new OoaStaticListCastVisitor(coverType));
+
+				expression.SetType(new ListType(coverType.innerType(), la.maxNumberOfElements() + lb.maxNumberOfElements(), null));
+			} else
+				expression.SetType(new ListType(la.innerType(), la.maxNumberOfElements() + lb.maxNumberOfElements(), null));
 			break;
 
 			/*numeric binary*/
@@ -1411,6 +1470,19 @@
 							return Error(expression, "Free variables on both sides of the equality sign in tuple constructors.");
 						m_matcherList.remove(rhs);
 					}
+
+					/* This adds support for "equality-style assignments" in expressions. Not yet supported by the backend though :(
+					if (lhs.type().kind() == TypeKind.Any || rhs.type().kind() == TypeKind.Any)
+					{
+						if (lhs.type().kind() == TypeKind.Any && rhs.type().kind() == TypeKind.Any)
+							return Error(expression, "Free variables on both sides of equality sign.");
+						// free var - so set type and mark initialized
+						final AnyType freevar =  lhs.type().kind() == TypeKind.Any ? (AnyType)lhs.type() : (AnyType)rhs.type();
+						freevar.VariableIdentifier().SetType(cover);
+						freevar.VariableIdentifier().SetInitialized(true);
+						lhs.SetType(cover);
+					}
+					*/
 				}
 
 				lhs = UnaryOperator.TryCoerceUp(lhs, cover);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypeCheckVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypeCheckVisitor.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/visitors/OoaTypeCheckVisitor.java	(revision 12)
@@ -49,6 +49,7 @@
 import org.momut.ooas.ast.statements.KillStatement;
 import org.momut.ooas.ast.statements.Statement;
 import org.momut.ooas.ast.types.FunctionType;
+import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.TypeKind;
 import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.parser.ParserError;
@@ -390,18 +391,34 @@
 					Error(attributeIdentifier, String.format("Type mismatch in attribute initializer: %s ( %s := %s )", attributeIdentifier.toString(), idtype.toString(), acover.toString()));
 				else
 				{
-					final Expression constantvalue = attributeIdentifier.initializer().kind() == ExpressionKind.Value ? attributeIdentifier.initializer() : null;
-
 					if (!Type.TypeEqual(atype, acover))
 					{
-						final UnaryOperator cast = new UnaryOperator(ExpressionKind.Cast, attributeIdentifier.initializer(),
-								attributeIdentifier.initializer().line(), attributeIdentifier.initializer().pos());
-						cast.SetType(acover);
-						attributeIdentifier.SetInitializer(cast);
+						if(acover.kind() == TypeKind.ListType)
+						{
+							attributeIdentifier.initializer().Accept(new OoaStaticListCastVisitor((ListType) acover));
+
+							// now check whether the list lengths are ok
+							((ListType) atype).SetInnerType(((ListType) idtype).innerType());
+							final Type lengthCover = Type.CoverType(idtype, attributeIdentifier.initializer().type());
+							if (!Type.TypeEqual(atype, lengthCover)) {
+								final UnaryOperator cast = new UnaryOperator(ExpressionKind.Cast, attributeIdentifier.initializer(),
+										attributeIdentifier.initializer().line(), attributeIdentifier.initializer().pos());
+								cast.SetType(lengthCover);
+								attributeIdentifier.SetInitializer(cast);
+							}
+						}
+						else
+						{
+							final UnaryOperator cast = new UnaryOperator(ExpressionKind.Cast, attributeIdentifier.initializer(),
+									attributeIdentifier.initializer().line(), attributeIdentifier.initializer().pos());
+							cast.SetType(acover);
+							attributeIdentifier.SetInitializer(cast);
+						}
 					}
 
 					if (Type.FirstTypeLessRange(idtype, acover))
 					{
+						final Expression constantvalue = attributeIdentifier.initializer().kind() == ExpressionKind.Value ? attributeIdentifier.initializer() : null;
 						if (constantvalue == null)
 						{
 							Warning(attributeIdentifier, String.format("Assignment may over/underflow: %s := %s", idtype.toString(), acover.toString()));
@@ -416,17 +433,6 @@
 						}
 					}
 				}
-
-				/*
-
-
-                if (cover == null || !UlyssesType.TypeEqual(cover, idtype))
-                    Error(attributeIdentifier,
-                        String.Format("Type mismatch in attribute initializer: expected '%s', found '%s'",
-                            idtype.ToString(), atype.ToString()));
-                else
-                    attributeIdentifier.SetInitializer(UnaryOperator.CoerceUp(attributeIdentifier.initializer, idtype));
-				 * */
 			}
 		}
 	}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/IAstVisitor.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/IAstVisitor.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/IAstVisitor.java	(revision 12)
@@ -79,6 +79,7 @@
 import org.momut.ooas.ast.types.IntType;
 import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.MapType;
+import org.momut.ooas.ast.types.MetaType;
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemType;
 import org.momut.ooas.ast.types.OpaqueType;
@@ -154,6 +155,7 @@
 	void visit(OpaqueType opaqueType);
 	void visit(AnyType anyType);
 	void visit(NullType nullType);
+	void visit(MetaType metaType);
 
 	void visit(BreakStatement breakStatement);
 }
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/TypeExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/TypeExpression.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/expressions/TypeExpression.java	(revision 12)
@@ -28,6 +28,7 @@
 package org.momut.ooas.ast.expressions;
 
 import org.momut.ooas.ast.IAstVisitor;
+import org.momut.ooas.ast.types.MetaType;
 import org.momut.ooas.ast.types.Type;
 
 ///////////////////////////////////////////////
@@ -35,24 +36,32 @@
 ///
 public class TypeExpression extends LeafExpression
 {
+	protected Type m_referredType;
+
+	public Type referredType() {return m_referredType;}
+//	public void setReferredType(Type aType) {m_referredType = aType;}
+
 	public TypeExpression(Type atype, int line, int pos)
 	{
 		super (LeafTypeEnum.type, ExpressionKind.Type, line, pos);
-		m_type = atype;
+		m_type = new MetaType(atype);
+		m_referredType = atype;
 	}
 
 	public TypeExpression(TypeExpression toCopy)
 	{
 		super (toCopy);
+		m_referredType = toCopy.m_referredType;
 	}
 
 	@Override
-	public /*override*/ Expression Clone()
+	public Expression Clone()
 	{
 		return new TypeExpression(this);
 	}
 
-	public /*override*/ void Accept(IAstVisitor visitor)
+	@Override
+	public void Accept(IAstVisitor visitor)
 	{
 		visitor.visit(this);
 	}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/MetaType.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/MetaType.java	(nonexistent)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/MetaType.java	(revision 12)
@@ -0,0 +1,51 @@
+/**
+  *
+  *                      OOAS Compiler
+  *
+  * Copyright 2015, AIT Austrian Institute of Technology. All rights reserved.
+  *
+  * SEE THE "LICENSE" FILE FOR THE TERMS UNDER WHICH THIS FILE IS PROVIDED.
+  *
+  * If you modify the file please update the list of contributors below to in-
+  * clude your name. Please also stick to the coding convention of using TABs
+  * to do the basic (block-level) indentation and spaces for anything after
+  * that. (Enable the display of special chars and it should be pretty obvious
+  * what this means.) Also, remove all trailing whitespace.
+  *
+  * Contributors:
+  *               Willibald Krenn (AIT)
+  */
+
+
+package org.momut.ooas.ast.types;
+
+import org.momut.ooas.ast.IAstVisitor;
+
+///////////////////////////////////////////////
+///  Special type: MetaType (type of <Type> construct)
+///
+public final class MetaType extends Type
+{
+	private final Type m_type;
+
+	public Type Type() { return m_type; }
+
+	public MetaType(Type aType)
+	{
+		super(TypeKind.MetaType, null);
+		m_type = aType;
+	}
+
+	@Override
+	public void Accept(IAstVisitor visitor)
+	{
+		visitor.visit(this);
+	}
+
+	@Override
+	public String AnonymousName()
+	{
+		return "meta_" + m_type.AnonymousName();
+	}
+
+}
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/Type.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/Type.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/Type.java	(revision 12)
@@ -284,15 +284,16 @@
 						 * A cover type of a list must not change the size of the inner type. Mostly what is
 						 * allowed to change is the list length.
 						 */
-						Type subtype = listt1.innerType();
-						final boolean castAllowed = TypeEqual(listt1.innerType(), listt2.innerType())
-						          || (    (listt1.innerType().kind() == TypeKind.OoActionSystemType)
-						               && (subtype = Type.CoverType(listt1.innerType(), listt2.innerType())) != null);
+						final Type innerType1 = listt1.innerType();
+						final Type innerType2 = listt2.innerType();
+						Type resultInner = innerType1;
+						final boolean castAllowed = TypeEqual(innerType1, innerType2)
+						          ||     (resultInner = Type.CoverType(innerType1, innerType2)) != null;
 						if (castAllowed){
 							final int maxelems = listt1.maxNumberOfElements() > listt2.maxNumberOfElements()
 							                ? listt1.maxNumberOfElements()
 							                : listt2.maxNumberOfElements();
-							return new ListType(subtype, maxelems, null);
+							return new ListType(resultInner, maxelems, null);
 						} else
 							return null;
 
@@ -438,6 +439,8 @@
 				return false;
 			case OoActionSystemType:
 				return false;
+			case MetaType:
+				return Type.FirstTypeLessRange( ((MetaType)type1).Type() , ((MetaType)type2).Type());
 			case OpaqueType:
 				assert(false);
 				return false;
@@ -494,6 +497,8 @@
 				return true;
 			case OoActionSystemType:
 				return type1 == type2; // ref equ.
+			case MetaType:
+				return Type.TypeEqualByKind( ((MetaType)type1).Type() , ((MetaType)type2).Type());
 			case OpaqueType:
 				assert(false);
 				return false;
@@ -569,6 +574,8 @@
 				return true;
 			case OoActionSystemType:
 				return type1 == type2; // ref equ. // || Covariance((OoActionSystemType)type1, (OoActionSystemType)type2);
+			case MetaType:
+				return Type.TypeEqual( ((MetaType)type1).Type() , ((MetaType)type2).Type());
 			case OpaqueType:
 				assert(false);
 				return false;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TypeKind.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TypeKind.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/ast/types/TypeKind.java	(revision 12)
@@ -35,7 +35,7 @@
 	EnumeratedType(3),
 	ListType(4),
 	MapType(5),
-//	QrType(6),               // no longer supported
+	MetaType(6),
 	TupleType(7),
 	FunctionType(8),
 	OoActionSystemType(9),
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/IAstDuplicator.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/IAstDuplicator.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/IAstDuplicator.java	(revision 12)
@@ -242,6 +242,13 @@
 			T innerTypeRef,
 			int maxNumberOfElements);
 
+	/** Initialize a meta type */
+	boolean initMetaType(
+			T typeId,
+			T identifierRef,
+			boolean anonymousType,
+			T innerTypeRef);
+
 	/** Initialize a tuple type */
 	boolean initTupleType(
 			T typeId,
@@ -367,7 +374,8 @@
 			int pos,
 			T typeRef,
 			T callTargetsIdentifierListRef,
-			T symbTabRef);
+			T symbTabRef,
+			T referredTypeRef);
 
 	/** Initialize an identifier expression */
 	boolean initIdentifierExpression(
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/OoaAstEmitter.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/OoaAstEmitter.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/OoaAstEmitter.java	(revision 12)
@@ -93,6 +93,7 @@
 import org.momut.ooas.ast.types.IntType;
 import org.momut.ooas.ast.types.ListType;
 import org.momut.ooas.ast.types.MapType;
+import org.momut.ooas.ast.types.MetaType;
 import org.momut.ooas.ast.types.NullType;
 import org.momut.ooas.ast.types.OoActionSystemInstance;
 import org.momut.ooas.ast.types.OoActionSystemType;
@@ -645,7 +646,23 @@
 				listType.maxNumberOfElements());
 	}
 
+	@Override
+	public void visit(MetaType metaType)
+	{
+		final T type = createType(metaType);
 
+		final Identifier id = metaType.identifier();
+		VisitSub(id, metaType);
+		VisitSub(metaType.Type(), metaType);
+
+		m_copier.initMetaType(
+				type,
+				m_convertedIdentifiers.get(id),
+				metaType.isAnonymousType(),
+				m_convertedTypes.get(metaType.Type()));
+	}
+
+
 	@Override
 	public void visit(TupleType tupleType)
 	{
@@ -1007,6 +1024,8 @@
 	{
 		final T expr = createExpression(typeExpression);
 		final ExprData d = visitBasicExpression(typeExpression);
+		VisitSub(typeExpression.referredType(), typeExpression);
+
 		m_copier.initTypeExpression(
 				expr,
 				d.line,
@@ -1013,7 +1032,8 @@
 				d.pos,
 				d.typeRef,
 				d.callTargetsIdentifierListRef,
-				d.symbTabRef);
+				d.symbTabRef,
+				m_convertedTypes.get(typeExpression.referredType()));
 	}
 
 	@Override
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/protobuf/AstProtoBufRecorder.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/protobuf/AstProtoBufRecorder.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/ast/protobuf/AstProtoBufRecorder.java	(revision 12)
@@ -83,7 +83,7 @@
 	}
 
 	private PBParameter.Builder stringParameter(String text){
-		return PBParameter.newBuilder().setLiteralValue(text);
+		return PBParameter.newBuilder().setLiteralValue(text == null ? "" : text);
 	}
 
 	private PBParameter.Builder boolParameter(boolean value){
@@ -594,6 +594,22 @@
 	}
 
 	@Override
+	public boolean initMetaType(Long typeId, Long identifierRef,
+			boolean anonymousType, Long innerTypeRef) {
+
+//		DLL bool TIRESIAS_INIT_METATYPE(void* context, void* typeId,
+//		void* identifierRef, bool anonymousType,
+//		void* innerTypeRef);
+		boolCall(PBTypes.TIRESIAS_INIT_METATYPE
+				, referenceParameter(typeId)
+				, referenceParameter(identifierRef)
+				, boolParameter(anonymousType)
+				, referenceParameter(innerTypeRef));
+
+		return true;
+	}
+
+	@Override
 	public boolean initTupleType(Long typeId, Long identifierRef,
 			boolean anonymousType, Long typeListRef) {
 
@@ -840,11 +856,11 @@
 
 	@Override
 	public boolean initTypeExpression(Long expr, int line, int pos,
-			Long typeRef, Long callTargetsIdentifierListRef, Long symbTabRef) {
+			Long typeRef, Long callTargetsIdentifierListRef, Long symbTabRef, Long referredTypeRef) {
 
 //		DLL bool TIRESIAS_INIT_TYPEEXPRESSION(void* context,
 //				void* expr, std::int32_t line, std::int32_t pos, void* typeRef,
-//				void* callTargetsIdentifierListRef, void* symbTabRef);
+//				void* callTargetsIdentifierListRef, void* symbTabRef, void* referredTypeRef);
 
 		boolCall(PBExpressions.TIRESIAS_INIT_TYPEEXPRESSION
 				, referenceParameter(expr)
@@ -852,7 +868,8 @@
 				, int32Parameter(pos)
 				, referenceParameter(typeRef)
 				, referenceParameter(callTargetsIdentifierListRef)
-				, referenceParameter(symbTabRef));
+				, referenceParameter(symbTabRef)
+				, referenceParameter(referredTypeRef));
 		return true;
 	}
 
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpExpression.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/cadp/CadpExpression.java	(revision 12)
@@ -213,7 +213,7 @@
 	@Override
 	public  void visit(TypeExpression typeExpression)
 	{
-		m_emitter.Append(typeExpression.type().identifier().tokenText());
+		m_emitter.Append(typeExpression.referredType().identifier().tokenText());
 	}
 
 	@Override
@@ -438,7 +438,7 @@
 	{
 		// if this instanceof some "<enumType>.<enumValue>" access, then just print the numeric value of <enumValue>
 		if (accessExpression.left().kind() == ExpressionKind.Type &&
-		    ((TypeExpression)accessExpression.left()).type().kind() == TypeKind.EnumeratedType )
+		    ((TypeExpression)accessExpression.left()).referredType().kind() == TypeKind.EnumeratedType )
 		{
 			accessExpression.right().Accept(this);
 			return;
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaExpression.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/java/JavaExpression.java	(revision 12)
@@ -184,8 +184,8 @@
 	@Override
 	public void visit(TypeExpression typeExpression)
 	{
-		if (typeExpression.type().kind() != TypeKind.EnumeratedType)
-			m_emitter.Append(GetIdentifierString(typeExpression.type().identifier().tokenText()));
+		if (typeExpression.referredType().kind() != TypeKind.EnumeratedType)
+			m_emitter.Append(GetIdentifierString(typeExpression.referredType().identifier().tokenText()));
 	}
 
 
@@ -315,7 +315,8 @@
 	@Override
 	public void visit(AccessExpression accessExpression)
 	{
-		if (accessExpression.left().type().kind() != TypeKind.EnumeratedType)
+		if (accessExpression.left().type().kind() != TypeKind.MetaType)
+//		if (accessExpression.left().type().kind() != TypeKind.EnumeratedType)
 		{
 			// enums and qr types are directly (statically) converted to nums...
 			VisitSub(accessExpression.left(), accessExpression);
Index: trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologExpression.java
===================================================================
--- trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologExpression.java	(revision 11)
+++ trunk/compiler/ooasCompiler/src/org/momut/ooas/codegen/prolog/OoaPrologExpression.java	(revision 12)
@@ -53,6 +53,7 @@
 import org.momut.ooas.ast.identifiers.IdentifierKind;
 import org.momut.ooas.ast.types.EnumType;
 import org.momut.ooas.ast.types.FunctionType;
+import org.momut.ooas.ast.types.MetaType;
 import org.momut.ooas.ast.types.TypeKind;
 import org.momut.ooas.ast.types.Type;
 import org.momut.ooas.ast.types.ValuedEnumType;
@@ -282,9 +283,9 @@
 	@Override
 	public void visit(TypeExpression typeExpression)
 	{
-		if (typeExpression.type().kind() != TypeKind.EnumeratedType)
+		if (typeExpression.referredType().kind() != TypeKind.EnumeratedType)
 		{
-			m_emitter.Append(GetIdentifierString(typeExpression.type().identifier()));
+			m_emitter.Append(GetIdentifierString(typeExpression.referredType().identifier()));
 		}
 	}
 
@@ -411,7 +412,7 @@
 	@Override
 	public void visit(AccessExpression accessExpression)
 	{
-		if (accessExpression.left().type().kind() != TypeKind.EnumeratedType &&
+		if (!(accessExpression.left().type().kind() == TypeKind.MetaType && ((MetaType)accessExpression.left().type()).Type().kind() == TypeKind.EnumeratedType ) &&
 		    !(accessExpression.right().kind() == ExpressionKind.Identifier &&
 		    ((IdentifierExpression)accessExpression.right()).identifier().kind() == IdentifierKind.AttributeIdentifier))
 		{
